class Fractal {
  ArrayList<Fractal> children;
  Fractal parent;
  int level = 0;
  int max = 10;
  
  PVector start, end;
  
  public Fractal (float sx, float sy, float ex, float ey) {
    parent = null;
    level = 0;
    children = new ArrayList<Fractal>();
    start = new PVector (sx,sy);
    end = new PVector (ex,ey);
    
    PVector dir = PVector.sub(end,start);
    
    children.add(new Fractal(this,dir));
    children.add(new Fractal(this,dir.rotate(-0.2)));
    children.add(new Fractal(this,dir.rotate(0.4)));
  }
  
  public Fractal (Fractal parent, PVector d) {
    this.parent = parent;
    level = parent.level+1;
    children = new ArrayList<Fractal>();
    
    start = parent.end;
    end = PVector.add(start,d);
    
    if (exitCondition()) return;
    PVector dir = PVector.sub(end,start);
    
    children.add(new Fractal(this,dir));
    children.add(new Fractal(this,dir.rotate(-0.2)));
    children.add(new Fractal(this,dir.rotate(0.4)));
  }
  
  boolean exitCondition () {
    return level>max;
  }
  
  void draw () {
    line(start.x,start.y,end.x,end.y);
    for (int c=0; c<children.size(); c++) children.get(c).draw();
  }
}

void setup () {
  size(800,800);
  Fractal f;
  f = new Fractal(400,800, 400, 750);
  stroke(0,100);
  f.draw();
}
